package ua.in.konvert.groovyconsole

import com.intellij.ide.plugins.PluginManager
import com.intellij.openapi.actionSystem.ActionManager
import com.intellij.openapi.actionSystem.AnAction
import java.awt.event.ActionEvent
import javax.swing.KeyStroke
import java.awt.event.KeyEvent

def pluginId = OpenGroovyConsoleAction.classLoader.getPluginId()
def pluginDescriptor = PluginManager.getPlugin(pluginId)
def loaders = PluginManager.getPlugins().grep{it.isEnabled()}.pluginClassLoader
def pluginClassLoader = PluginManager.createPluginClassLoader(pluginDescriptor.getClassPath() as File[], loaders as ClassLoader[], pluginDescriptor)
c = new groovy.ui.Console(pluginClassLoader)
c.run()


//restore normal key bindings for HOME, END ant Ctrl+W keys (thanks to IntelliJ crappy action manager)
callAction = {c.inputEditor.textEditor.actionMap.get(it).actionPerformed(new ActionEvent(c.inputEditor.textEditor, 0, null))}


pg = new ProxyGenerator(override:OpenGroovyConsoleAction.classLoader)
createAction = {clos -> pg.instantiateAggregate([actionPerformed:{clos()}], [], AnAction)}

goHomeAction      = createAction{ callAction('caret-begin-line') }
goEndAction       = createAction{ callAction('caret-end-line') }
selectHomeAction  = createAction{ callAction('selection-begin-line') }
selectEndAction   = createAction{ callAction('selection-end-line') }
clearOutputAction = createAction{ c.clearOutput() }

goHomeAction     .registerCustomShortcutSet(KeyEvent.VK_HOME, 0, c.inputEditor.textEditor)
goEndAction      .registerCustomShortcutSet(KeyEvent.VK_END,  0, c.inputEditor.textEditor)
selectHomeAction .registerCustomShortcutSet(KeyEvent.VK_HOME, KeyEvent.SHIFT_DOWN_MASK, c.inputEditor.textEditor)
selectEndAction  .registerCustomShortcutSet(KeyEvent.VK_END,  KeyEvent.SHIFT_DOWN_MASK, c.inputEditor.textEditor)
clearOutputAction.registerCustomShortcutSet(KeyEvent.VK_W,    KeyEvent.CTRL_DOWN_MASK,  c.inputEditor.textEditor)
