package ua.in.konvert.groovyconsole;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import groovy.lang.GroovyClassLoader;
import org.codehaus.groovy.runtime.InvokerHelper;

import javax.swing.*;

/**
 * User: Sergey Bondarenko
 * Date: 07.03.2010
 */
public class OpenGroovyConsoleAction extends AnAction {
    static Class consoleScriptClass;

    private static void loadConsoleScriptClass() {
        GroovyClassLoader loader = new GroovyClassLoader(OpenGroovyConsoleAction.class.getClassLoader());
        consoleScriptClass = loader.parseClass(OpenGroovyConsoleAction.class.getResourceAsStream("ConsoleScript.groovy"));
    }

    public void actionPerformed(AnActionEvent event) {
    /* the following line is useful for experiments with console script itself.
     * uncomment if you want console script to be reloaded every time when it is invoked from the menu
     */
//        loadConsoleScriptClass();   
        if (consoleScriptClass == null) loadConsoleScriptClass(); //lazy loading
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            InvokerHelper.invokeMethod(consoleScriptClass.newInstance(), "run", null);
        } catch (Exception e) {
            throw new Error(e);
        }
    }
}
